/**
 * Implicit Inc. - Implicit for Teams
 * Add record as tab to Microsoft Teams
 *
 * @class View.Fields.Base.IfeAddToMsTeamsRowactionField
 * @alias SUGAR.App.view.fields.BaseIfeAddToMsTeamsRowactionField
 * @extends View.Fields.Base.RowactionField
 */
({
    extendsFrom: 'RowactionField',

    initialize: function (options) {
        this._super('initialize', [options]);
    },

    rowActionSelect: function (evt) {
        this.ifeAddToTeams();
    },

    ifeAddToTeams: function () {
        var popup = document.getElementById("ifePopupAddToTeams");
        if(popup) {
            popup.remove();
        }

        var module = this.module || this.model.module || ((this.context && this.context.get('module')) ? this.context.get('module') : null);
        
        popup = document.createElement("div");
        popup.id = "ifePopupAddToTeams";
        popup.className = "modal fade"
        popup.style.display = "none";
        popup.innerHTML = `
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header" style="display:none">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title">Share via Teams</h4>
                </div>
                <div class="modal-body p-0" style="max-height: unset;overflow-y:hidden">
                    <div style="height: 450px;">
                        <iframe src="https://apps.crmcollaboration.com/teams-sugarcrm/addtoteams?module=${module}&id=${this.model.id}&name=${this.model.get('name')}" style="height: 100%; width: 100%; border: 0px;"></iframe>
                    </div>
                </div>
                <div class="modal-footer" style="display:none">&nbsp;<button type="button" class="btn btn-primary" data-dismiss="modal">Cancel</button></div>
            </div>
        </div>`;
        document.body.appendChild(popup);

        window.addEventListener('message', function (event) {
            if(event.data && event.data.ifePopupAddToTeams) {
                var p = document.getElementById("ifePopupAddToTeams");
                if(p) {
                    $('#ifePopupAddToTeams').modal('hide');
                    p.remove();
                }
            }
        });
        $("#ifePopupAddToTeams").modal("show", { backdrop: "static" });
    }
})