<?php

    if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

    class ifeHooks
    {
        function set_implicit_csp($event, $arguments)
        {
            try
            {
                $headers = headers_list();
                if(empty($headers)) {
                    return;
                }

                $csp = "";
                for($i = 0; $i < count($headers); $i++) {
                    if(stripos($headers[$i], "Content-Security-Policy:") === 0) {
                        $csp = trim(substr($headers[$i], strlen("Content-Security-Policy:")));
                        break;
                    }
                }

                if(empty($csp)) {
                    return;
                }

                $GLOBALS['log']->debug("Implicit CSP: header - " . $csp);

                $parts = explode(';', $csp);

                for($i = 0; $i < count($parts); $i++) {
                    if(stripos(trim($parts[$i]), "default-src") === 0) {
                        $parts[$i] = $parts[$i] . " https://apps.crmcollaboration.com";
                    }
                    if(stripos(trim($parts[$i]), "frame-src") === 0) {
                        $parts[$i] = $parts[$i] . " https://apps.crmcollaboration.com";
                    }
                    if(stripos(trim($parts[$i]), "child-src") === 0) {
                        $parts[$i] = $parts[$i] . " https://apps.crmcollaboration.com";
                    }
                }

                $csp = implode("; ", $parts);

                $GLOBALS['log']->debug("Implicit CSP: headers added - " . $csp);

                header('Content-Security-Policy: ' . $csp);
            }
            catch(Exception $e) {
                $GLOBALS['log']->fatal("Implicit CSP: Error - " . $e->getMessage());
            }
        }
    }

?>